# std::deque< _Tp, _Alloc > Class Template Reference
[Containers, Sequences]

Inheritance diagram for std::deque< _Tp, _Alloc >:

List of all members.

## Detailed Description

### template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
class std::deque< _Tp, _Alloc >

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements.

In previous HP/SGI versions of deque, there was an extra template parameter so users could control the node size. This extension turned out to violate the C++ standard (it can be detected using template template parameters), and it was removed.

Definition at line 629 of file stl_deque.h.

## Public Types

- typedef _Alloc allocator_type
- typedef _Base::const_iterator const_iterator
- typedef _Tp_alloc_type::const_pointer const_pointer
- typedef _Tp_alloc_type::const_reference const_reference
- typedef std::reverse_iterator<
  const_iterator > const_reverse_iterator
- typedef ptrdiff_t difference_type
- typedef _Base::iterator iterator
- typedef _Tp_alloc_type::pointer pointer
- typedef _Tp_alloc_type::reference reference
- typedef std::reverse_iterator<
  iterator > reverse_iterator
- typedef size_t size_type
- typedef _Tp value_type

## Public Member Functions

- template<typename _InputIterator> void assign (_InputIterator __first, _InputIterator __last)
- void assign (size_type __n, const value_type &__val)
- const_reference at (size_type __n) const
- reference at (size_type __n)
- const_reference back () const
- reference back ()
- const_iterator begin () const
- iterator begin ()
- void clear ()
- template<typename _InputIterator> deque (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
- deque (const deque &__x)
- deque (size_type __n, const value_type &__value=value_type(), const allocator_type &__a=allocator_type())
- deque (const allocator_type &__a=allocator_type())
- bool empty () const
- const_iterator end () const
- iterator end ()
- iterator erase (iterator __first, iterator __last)
- iterator erase (iterator __position)
- const_reference front () const
- reference front ()
- allocator_type get_allocator () const
- template<typename _InputIterator> void insert (iterator __position, _InputIterator __first, _InputIterator __last)
- void insert (iterator __position, size_type __n, const value_type &__x)
- iterator insert (iterator __position, const value_type &__x)
- size_type max_size () const
- deque & operator= (const deque &__x)
- const_reference operator[] (size_type __n) const
- reference operator[] (size_type __n)
- void pop_back ()
- void pop_front ()
- void push_back (const value_type &__x)
- void push_front (const value_type &__x)
- const_reverse_iterator rbegin () const
- reverse_iterator rbegin ()
- const_reverse_iterator rend () const
- reverse_iterator rend ()
- void resize (size_type __new_size, value_type __x=value_type())
- size_type size () const
- void swap (deque &__x)
- ~deque ()

## Protected Types

- enum { _S_initial_map_size }
- typedef _Alloc::template rebind<
  _Tp * >::other _Map_alloc_type
- typedef pointer * _Map_pointer

## Protected Member Functions

- _Tp ** _M_allocate_map (size_t __n)
- _Tp * _M_allocate_node ()
- template<typename _ForwardIterator> void _M_assign_aux (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
- template<typename _InputIterator> void _M_assign_aux (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
- template<typename _InputIterator> void _M_assign_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
- template<typename _Integer> void _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
- void _M_create_nodes (_Tp **__nstart, _Tp **__nfinish)
- void _M_deallocate_map (_Tp **__p, size_t __n)
- void _M_deallocate_node (_Tp *__p)
- void _M_destroy_data (iterator __first, iterator __last, const std::allocator< _Tp > &)
- template<typename _Alloc1> void _M_destroy_data (iterator __first, iterator __last, const _Alloc1 &)
- void _M_destroy_data_aux (iterator __first, iterator __last)
- void _M_destroy_data_dispatch (iterator __first, iterator __last, __false_type)
- void _M_destroy_data_dispatch (iterator, iterator, __true_type)
- void _M_destroy_nodes (_Tp **__nstart, _Tp **__nfinish)
- void _M_erase_at_begin (iterator __pos)
- void _M_erase_at_end (iterator __pos)
- void _M_fill_assign (size_type __n, const value_type &__val)
- void _M_fill_initialize (const value_type &__value)
- void _M_fill_insert (iterator __pos, size_type __n, const value_type &__x)
- _Map_alloc_type _M_get_map_allocator () const
- const _Tp_alloc_type & _M_get_Tp_allocator () const
- _Tp_alloc_type & _M_get_Tp_allocator ()
- template<typename _InputIterator> void _M_initialize_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
- template<typename _Integer> void _M_initialize_dispatch (_Integer __n, _Integer __x, __true_type)
- void _M_initialize_map (size_t)
- template<typename _ForwardIterator> void _M_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, size_type __n)
- void _M_insert_aux (iterator __pos, size_type __n, const value_type &__x)
- iterator _M_insert_aux (iterator __pos, const value_type &__x)
- template<typename _InputIterator> void _M_insert_dispatch (iterator __pos, _InputIterator __first, _InputIterator __last, __false_type)
- template<typename _Integer> void _M_insert_dispatch (iterator __pos, _Integer __n, _Integer __x, __true_type)
- void _M_range_check (size_type __n) const
- template<typename _ForwardIterator> void _M_range_insert_aux (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
- template<typename _InputIterator> void _M_range_insert_aux (iterator __pos, _InputIterator __first, _InputIterator __last, std::input_iterator_tag)

- void _M_new_elements_at_back (size_type __new_elements)
- void _M_new_elements_at_front (size_type __new_elements)
- iterator _M_reserve_elements_at_back (size_type __n)
- iterator _M_reserve_elements_at_front (size_type __n)

- void _M_pop_back_aux ()
- void _M_pop_front_aux ()
- void _M_push_back_aux (const value_type &)
- void _M_push_front_aux (const value_type &)

- template<typename _ForwardIterator> void _M_range_initialize (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
- template<typename _InputIterator> void _M_range_initialize (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)

- void _M_reallocate_map (size_type __nodes_to_add, bool __add_at_front)
- void _M_reserve_map_at_back (size_type __nodes_to_add=1)
- void _M_reserve_map_at_front (size_type __nodes_to_add=1)

## Static Protected Member Functions

- static size_t _S_buffer_size ()

## Protected Attributes

- _Deque_impl _M_impl

## Constructor & Destructor Documentation

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | const allocator_type & | __a = `allocator_type()` | ) | `[inline, explicit]`

Default constructor creates no elements.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 683 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | size_type | __n,
|  | const value_type & | __value = `value_type()`,
|  | const allocator_type & | __a = `allocator_type()` |
| ) |  |  | `[inline, explicit]`

Create a deque with copies of an exemplar element.

Parameters:

  | n | The number of elements to initially create.
  | value | An element to copy.

This constructor fills the deque with n copies of value.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 694 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::deque | ( | const deque< _Tp, _Alloc > & | __x | ) | `[inline]`

Deque copy constructor.

Parameters:

  | x | A deque of identical element and allocator types.

The newly-created deque uses a copy of the allocation object used by x.

Definition at line 706 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator>

std::deque< _Tp, _Alloc >::deque | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a = `allocator_type()` |
| ) |  |  | `[inline]`

Builds a deque from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Create a deque consisting of copies of the elements from [first, last).

If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(first,last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 727 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

std::deque< _Tp, _Alloc >::~deque | ( |  | ) | `[inline]`

The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 741 of file stl_deque.h.

## Member Function Documentation

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator>

void std::deque< _Tp, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Assigns a range to a deque.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

This function fills a deque with copies of the elements in the range [first,last).

Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 782 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::assign | ( | size_type | __n,
|  | const value_type & | __val |
| ) |  |  | `[inline]`

Assigns a given value to a deque.

Parameters:

  | n | Number of elements to be assigned.
  | val | Value to be assigned.

This function fills a deque with n copies of the given value. Note that the assignment completely changes the deque and that the resulting deque's size is the same as the number of elements assigned. Old data may be lost.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 765 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::at | ( | size_type | __n | ) | const`[inline]`

Provides access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 975 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::at | ( | size_type | __n | ) | `[inline]`

Provides access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the deque. The function throws out_of_range if the check fails.

Definition at line 957 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::back | ( |  | ) | const`[inline]`

Returns a read-only (constant) reference to the data at the last element of the deque.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 1014 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::back | ( |  | ) | `[inline]`

Returns a read/write reference to the data at the last element of the deque.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 1002 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::_M_insert_aux().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::begin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 807 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::begin | ( |  | ) | `[inline]`

Returns a read/write iterator that points to the first element in the deque. Iteration is done in ordinary element order.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 799 of file stl_deque.h.

Referenced by std::deque< _Tp, _Allocator >::_M_assign_aux(), std::deque< _Tp, _Alloc >::_M_assign_aux(), std::deque< _Tp, _Allocator >::_M_erase_at_begin(), std::deque< _Tp, _Allocator >::_M_fill_assign(), std::deque< _Tp, _Allocator >::clear(), std::deque< _Tp, _Allocator >::deque(), std::deque< _Tp, _Alloc >::erase(), std::deque< _Tp, _Allocator >::front(), std::operator==(), and std::deque< _Tp, _Allocator >::~deque().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::clear | ( |  | ) | `[inline]`

Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 1217 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::_M_range_initialize(), and std::deque< _Tp, _Alloc >::erase().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

bool std::deque< _Tp, _Alloc >::empty | ( |  | ) | const`[inline]`

Returns true if the deque is empty. (Thus begin() would equal end().)

Definition at line 901 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_iterator std::deque< _Tp, _Alloc >::end | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 825 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

iterator std::deque< _Tp, _Alloc >::end | ( |  | ) | `[inline]`

Returns a read/write iterator that points one past the last element in the deque. Iteration is done in ordinary element order.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 816 of file stl_deque.h.

Referenced by std::deque< _Tp, _Allocator >::_M_assign_aux(), std::deque< _Tp, _Alloc >::_M_assign_aux(), std::deque< _Tp, _Allocator >::_M_erase_at_end(), std::deque< _Tp, _Allocator >::_M_fill_assign(), std::deque< _Tp, _Allocator >::back(), std::deque< _Tp, _Allocator >::deque(), std::deque< _Tp, _Alloc >::erase(), std::operator==(), and std::deque< _Tp, _Allocator >::~deque().

template<typename _Tp, typename _Alloc>

deque< _Tp, _Alloc >::iterator std::deque< _Tp, _Alloc >::erase | ( | iterator | __first,
|  | iterator | __last |
| ) |  |  |

Remove a range of elements.

Parameters:

  | first | Iterator pointing to the first element to be erased.
  | last | Iterator pointing to one past the last element to be erased.

Returns:
  An iterator pointing to the element pointed to by last prior to erasing (or end()).

This function will erase the elements in the range [first,last) and shorten the deque accordingly.

The user is cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 135 of file deque.tcc.

References std::deque< _Tp, _Alloc >::_M_erase_at_begin(), std::deque< _Tp, _Alloc >::_M_erase_at_end(), std::deque< _Tp, _Alloc >::begin(), std::deque< _Tp, _Alloc >::clear(), std::copy_backward(), std::deque< _Tp, _Alloc >::end(), and std::deque< _Tp, _Alloc >::size().

template<typename _Tp, typename _Alloc>

deque< _Tp, _Alloc >::iterator std::deque< _Tp, _Alloc >::erase | ( | iterator | __position | ) |

Remove element at given position.

Parameters:

  | position | Iterator pointing to element to be erased.

Returns:
  An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the deque by one.

The user is cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 112 of file deque.tcc.

References std::deque< _Tp, _Alloc >::begin(), std::copy_backward(), std::deque< _Tp, _Alloc >::end(), std::deque< _Tp, _Alloc >::pop_back(), std::deque< _Tp, _Alloc >::pop_front(), and std::deque< _Tp, _Alloc >::size().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::front | ( |  | ) | const`[inline]`

Returns a read-only (constant) reference to the data at the first element of the deque.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 994 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::front | ( |  | ) | `[inline]`

Returns a read/write reference to the data at the first element of the deque.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 986 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::_M_insert_aux().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

allocator_type std::deque< _Tp, _Alloc >::get_allocator | ( |  | ) | const`[inline]`

Get a copy of the memory allocation object.

Reimplemented from std::_Deque_base< _Tp, _Alloc >.

Definition at line 790 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>
template<typename _InputIterator>

void std::deque< _Tp, _Alloc >::insert | ( | iterator | __position,
|  | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Inserts a range into the deque.

Parameters:

  | position | An iterator into the deque.
  | first | An input iterator.
  | last | An input iterator.

This function will insert copies of the data in the range [first,last) into the deque before the location specified by pos. This is known as "range insert."

Definition at line 1144 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::insert | ( | iterator | __position,
|  | size_type | __n,
|  | const value_type & | __x |
| ) |  |  | `[inline]`

Inserts a number of copies of given data into the deque.

Parameters:

  | position | An iterator into the deque.
  | n | Number of elements to be inserted.
  | x | Data to be inserted.

This function will insert a specified number of copies of the given data before the location specified by position.

Definition at line 1129 of file stl_deque.h.

template<typename _Tp, typename _Alloc>

deque< _Tp, _Alloc >::iterator std::deque< _Tp, _Alloc >::insert | ( | iterator | __position,
|  | const value_type & | __x |
| ) |  |  |

Inserts given value into deque before specified iterator.

Parameters:

  | position | An iterator into the deque.
  | x | Data to be inserted.

Returns:
  An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location.

Definition at line 91 of file deque.tcc.

References std::_Deque_iterator< _Tp, _Ref, _Ptr >::_M_cur, std::_Deque_base< _Tp, _Alloc >::_M_impl, std::deque< _Tp, _Alloc >::_M_insert_aux(), std::deque< _Tp, _Alloc >::push_back(), and std::deque< _Tp, _Alloc >::push_front().

Referenced by std::deque< _Tp, _Allocator >::_M_assign_aux(), std::deque< _Tp, _Alloc >::_M_assign_aux(), std::deque< _Tp, _Allocator >::_M_fill_assign(), and std::deque< _Tp, _Allocator >::resize().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::deque< _Tp, _Alloc >::max_size | ( |  | ) | const`[inline]`

Returns the size() of the largest possible deque.

Definition at line 872 of file stl_deque.h.

template<typename _Tp, typename _Alloc>

deque< _Tp, _Alloc > & std::deque< _Tp, _Alloc >::operator= | ( | const deque< _Tp, _Alloc > & | __x | ) |

Deque assignment operator.

Parameters:

  | x | A deque of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 70 of file deque.tcc.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reference std::deque< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | const`[inline]`

Subscript access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 932 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reference std::deque< _Tp, _Alloc >::operator[] | ( | size_type | __n | ) | `[inline]`

Subscript access to the data contained in the deque.

Parameters:

  | n | The index of the element for which data should be accessed.

Returns:
  Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 917 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::pop_back | ( |  | ) | `[inline]`

Removes last element.

This is a typical stack operation. It shrinks the deque by one.

Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 1095 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::erase().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::pop_front | ( |  | ) | `[inline]`

Removes first element.

This is a typical stack operation. It shrinks the deque by one.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop_front() is called.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 1074 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::erase().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::push_back | ( | const value_type & | __x | ) | `[inline]`

Add data to the end of the deque.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the end of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 1053 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::_M_insert_aux(), std::deque< _Tp, _Alloc >::_M_range_initialize(), and std::deque< _Tp, _Alloc >::insert().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::push_front | ( | const value_type & | __x | ) | `[inline]`

Add data to the front of the deque.

Parameters:

  | x | Data to be added.

This is a typical stack operation. The function creates an element at the front of the deque and assigns the given data to it. Due to the nature of a deque this operation can be done in constant time.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 1032 of file stl_deque.h.

Referenced by std::deque< _Tp, _Alloc >::_M_insert_aux(), and std::deque< _Tp, _Alloc >::insert().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::rbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 843 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::deque< _Tp, _Alloc >::rbegin | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to the last element in the deque. Iteration is done in reverse element order.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 834 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

const_reverse_iterator std::deque< _Tp, _Alloc >::rend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 861 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

reverse_iterator std::deque< _Tp, _Alloc >::rend | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to one before the first element in the deque. Iteration is done in reverse element order.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 852 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::resize | ( | size_type | __new_size,
|  | value_type | __x = `value_type()` |
| ) |  |  | `[inline]`

Resizes the deque to the specified number of elements.

Parameters:

  | new_size | Number of elements the deque should contain.
  | x | Data with which new elements should be populated.

This function will resize the deque to the specified number of elements. If the number is smaller than the deque's current size the deque is truncated, otherwise the deque is extended and new elements are populated with given data.

Reimplemented in std::__debug::deque< _Tp, _Allocator >.

Definition at line 887 of file stl_deque.h.

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

size_type std::deque< _Tp, _Alloc >::size | ( |  | ) | const`[inline]`

Returns the number of elements in the deque.

Definition at line 867 of file stl_deque.h.

Referenced by std::deque< _Tp, _Allocator >::_M_assign_aux(), std::deque< _Tp, _Allocator >::_M_fill_assign(), std::deque< _Tp, _Alloc >::_M_insert_aux(), std::deque< _Tp, _Alloc >::_M_new_elements_at_back(), std::deque< _Tp, _Alloc >::_M_new_elements_at_front(), std::deque< _Tp, _Alloc >::erase(), std::operator==(), and std::deque< _Tp, _Allocator >::resize().

template<typename _Tp, typename _Alloc = std::allocator<_Tp>>

void std::deque< _Tp, _Alloc >::swap | ( | deque< _Tp, _Alloc > & | __x | ) | `[inline]`

Swaps data with another deque.

Parameters:

  | x | A deque of the same element and allocator types.

This exchanges the elements between two deques in constant time. (Four pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(d1,d2) will feed to this function.

Definition at line 1197 of file stl_deque.h.

Referenced by std::swap().

The documentation for this class was generated from the following files:

- stl_deque.h
- deque.tcc